package SEU.module.complex;

import adf.agent.communication.MessageManager;
import adf.agent.communication.standard.bundle.MessageUtil;
import adf.agent.communication.standard.bundle.centralized.CommandAmbulance;
import adf.agent.communication.standard.bundle.centralized.MessageReport;
import adf.agent.communication.standard.bundle.information.MessageAmbulanceTeam;
import adf.agent.communication.standard.bundle.information.MessageCivilian;
import adf.agent.communication.standard.bundle.information.MessageFireBrigade;
import adf.agent.communication.standard.bundle.information.MessagePoliceForce;
import adf.agent.develop.DevelopData;
import adf.agent.info.AgentInfo;
import adf.agent.info.ScenarioInfo;
import adf.agent.info.WorldInfo;
import adf.agent.module.ModuleManager;
import adf.agent.precompute.PrecomputeData;
import adf.component.communication.CommunicationMessage;
import adf.component.module.complex.AmbulanceTargetAllocator;
import rescuecore2.standard.entities.*;
import rescuecore2.worldmodel.EntityID;

import java.util.*;

import static rescuecore2.standard.entities.StandardEntityURN.*;

public class SEUAmbulanceTargetAllocator extends AmbulanceTargetAllocator {
    private Collection<EntityID> priorityHumans;
    private Collection<EntityID> targetHumans;

    private Map<EntityID, AmbulanceTeamInfo> ambulanceTeamInfoMap;

    private Collection<EntityID>thewholetarget;
    
    public SEUAmbulanceTargetAllocator(AgentInfo ai, WorldInfo wi, ScenarioInfo si, ModuleManager moduleManager, DevelopData developData) {
        super(ai, wi, si, moduleManager, developData);
        this.priorityHumans = new HashSet<>();
        this.targetHumans = new HashSet<>();
        this.ambulanceTeamInfoMap = new HashMap<>();
        this.thewholetarget = new HashSet<>();
    }
    @Override
    public AmbulanceTargetAllocator resume(PrecomputeData precomputeData) {
        super.resume(precomputeData);
        if(this.getCountResume() >= 2) {
            return this;
        }
        for(EntityID id : this.worldInfo.getEntityIDsOfType(StandardEntityURN.AMBULANCE_TEAM)) {
            this.ambulanceTeamInfoMap.put(id, new AmbulanceTeamInfo(id));
        }
        return this;
    }
    /*we need to deal with TARGET(prioritu,targethumans) and AGENT(ambulanceTeam)
     * get the message to know the target and AT 
     * ATinfo include the action,targetID.
     * */
    @Override
    public AmbulanceTargetAllocator preparate() {
        super.preparate();
        if(this.getCountPrecompute() >= 2) {
            return this;
        }
        for(EntityID id : this.worldInfo.getEntityIDsOfType(StandardEntityURN.AMBULANCE_TEAM)) {
            this.ambulanceTeamInfoMap.put(id, new AmbulanceTeamInfo(id));
        }
        return this;
    }

    @Override
    public Map<EntityID, EntityID> getResult() {
        //return this.convert(this.ambulanceTeamInfoMap);
        return null;
    }

    @Override
    public AmbulanceTargetAllocator calc() {
        List<StandardEntity> agents = this.getActionAgents(this.ambulanceTeamInfoMap);
        List<EntityID> targetone = this.getlisttarget(this.priorityHumans);
        Collections.sort(targetone, new civilianSorter(this.worldInfo));
        
        System.out.println(this.agentInfo.getTime() + " action number is "+agents.size());
        Collection<EntityID> removes = new ArrayList<>();
        int currentTime = this.agentInfo.getTime();
        //System.out.println(this.agentInfo.getTime() + " target number is  "+this.targetHumans.size());
        for(EntityID target : this.priorityHumans) 
        {
            if(agents.size() > 0) 
            {
                StandardEntity targetEntity = this.worldInfo.getEntity(target);
                if (targetEntity != null && targetEntity instanceof Human && ((Human)targetEntity).isPositionDefined()) 
                {
                    agents.sort(new DistanceSorter(this.worldInfo, targetEntity));
                    //sort by the distance between target and agent
                    StandardEntity result = agents.get(0);
                    agents.remove(0);
                    AmbulanceTeamInfo info = this.ambulanceTeamInfoMap.get(result.getID());
                    if (info != null) 
                    {   
                    	//System.out.println(this.agentInfo.getTime()+" agent "+info.agentID+" target "+info.target);
                        info.canNewAction = false;
                        info.target = target;
                        info.commandTime = currentTime;
                        this.ambulanceTeamInfoMap.put(result.getID(), info);
                        removes.add(target);
                    }
                }
            }
        }//map is made of calc();
        this.priorityHumans.removeAll(removes);
        removes.clear();
        
        System.out.println(this.agentInfo.getTime() + " we have targethumans  "+this.targetHumans.size());
        for(EntityID target : this.targetHumans) {
        	calculateall(target);
            if(agents.size() > 0) {
                StandardEntity targetEntity = this.worldInfo.getEntity(target);
                if (targetEntity != null && targetEntity instanceof Human && ((Human)targetEntity).isPositionDefined()) {
                    agents.sort(new DistanceSorter(this.worldInfo, targetEntity));
                    StandardEntity result = agents.get(0);
                    agents.remove(0);
                    AmbulanceTeamInfo info = this.ambulanceTeamInfoMap.get(result.getID());
                    if(info != null) {
                    	//check the task contribution
                    	System.out.println(this.agentInfo.getTime()+" agent "+info.agentID+" get target "+info.target);
                        info.canNewAction = false;
                        info.target = target;
                        info.commandTime = currentTime;
                        this.ambulanceTeamInfoMap.put(result.getID(), info);
                        removes.add(target);
                    }
                }
            }
        }
        this.targetHumans.removeAll(removes);
        return this;
    }

    @Override
    public AmbulanceTargetAllocator updateInfo(MessageManager messageManager) 
    {
        super.updateInfo(messageManager);
        if(this.getCountUpdateInfo() >= 2) 
        {
            return this;
        }
        //the total messagemanager
        int currentTime = this.agentInfo.getTime();
        for(CommunicationMessage message : messageManager.getReceivedMessageList()) 
        {
            Class<? extends CommunicationMessage> messageClass = message.getClass();
            //Judge the method of message
            //civilian will belong to target
            if(messageClass == MessageCivilian.class) 
            {   
            	
            	System.out.println(this.agentInfo.getTime()+ " civilian message");
                MessageCivilian mc = (MessageCivilian) message;
                MessageUtil.reflectMessage(this.worldInfo, mc);
                calculateall(mc.getAgentID());
                System.out.println(this.agentInfo.getTime()+" id is "+mc.getAgentID()+" and buried "+mc.getBuriedness());
                if(mc.isBuriednessDefined() && mc.getBuriedness() > 0) 
                {
                    this.targetHumans.add(mc.getAgentID());
                } else 
                {
                    this.priorityHumans.remove(mc.getAgentID());
                    this.targetHumans.remove(mc.getAgentID());
                }
            } else if(messageClass == MessageFireBrigade.class) 
            {   //firebriade belong to priority
            	System.out.println(this.agentInfo.getTime()+ " firbriade message");
                MessageFireBrigade mfb = (MessageFireBrigade) message;
                MessageUtil.reflectMessage(this.worldInfo, mfb);
                if(mfb.isBuriednessDefined() && mfb.getBuriedness() > 0) 
                {
                    this.priorityHumans.add(mfb.getAgentID());
                } else 
                {
                    this.priorityHumans.remove(mfb.getAgentID());
                    this.targetHumans.remove(mfb.getAgentID());
                }
            } else if(messageClass == MessagePoliceForce.class) 
            {   //police belong to priority
            	System.out.println(this.agentInfo.getTime()+ " police message");
                MessagePoliceForce mpf = (MessagePoliceForce) message;
                MessageUtil.reflectMessage(this.worldInfo, mpf);
                if(mpf.isBuriednessDefined() && mpf.getBuriedness() > 0) 
                {
                    this.priorityHumans.add(mpf.getAgentID());
                }else 
                {
                    this.priorityHumans.remove(mpf.getAgentID());
                    this.targetHumans.remove(mpf.getAgentID());
                }
            }
        }
        //if the message belong to at,we will discuss
        for(CommunicationMessage message : messageManager.getReceivedMessageList(MessageAmbulanceTeam.class)) 
        {
        	System.out.println(this.agentInfo.getTime()+ " AT message");
            MessageAmbulanceTeam mat = (MessageAmbulanceTeam) message;
            MessageUtil.reflectMessage(this.worldInfo, mat);
            if(mat.isBuriednessDefined() && mat.getBuriedness() > 0) 
            {
                this.priorityHumans.add(mat.getAgentID());
            }else 
            {
                this.priorityHumans.remove(mat.getAgentID());
                this.targetHumans.remove(mat.getAgentID());
            }
            //judge the at
            AmbulanceTeamInfo info = this.ambulanceTeamInfoMap.get(mat.getAgentID());
            if(info == null) 
            {
                info = new AmbulanceTeamInfo(mat.getAgentID());
            }
            //create the map
            if(currentTime >= info.commandTime + 2) {
            	System.out.println(this.agentInfo.getTime() +" we have update it ");
                this.ambulanceTeamInfoMap.put(mat.getAgentID(), this.update(info, mat));
            }
        }
        for(CommunicationMessage message : messageManager.getReceivedMessageList(CommandAmbulance.class)) {
        	System.out.println(this.agentInfo.getTime()+ " command message");
            CommandAmbulance command = (CommandAmbulance)message;
            if(command.getAction() == CommandAmbulance.ACTION_RESCUE && command.isBroadcast()) {
                this.priorityHumans.add(command.getTargetID());
                this.targetHumans.add(command.getTargetID());
            } else if(command.getAction() == CommandAmbulance.ACTION_LOAD && command.isBroadcast()) {
                this.priorityHumans.add(command.getTargetID());
                this.targetHumans.add(command.getTargetID());
            }
        }
        for(CommunicationMessage message : messageManager.getReceivedMessageList(MessageReport.class)) {
        	System.out.println(this.agentInfo.getTime()+ " report message");
            MessageReport report = (MessageReport) message;
            AmbulanceTeamInfo info = this.ambulanceTeamInfoMap.get(report.getSenderID());
            if(info != null && report.isDone()) {
                info.canNewAction = true;
                this.priorityHumans.remove(info.target);
                this.targetHumans.remove(info.target);
                info.target = null;
                this.ambulanceTeamInfoMap.put(info.agentID, info);
            }
        }
        return this;
    }

    private Map<EntityID, EntityID> convert(Map<EntityID, AmbulanceTeamInfo> map) {
        Map<EntityID, EntityID> result = new HashMap<>();
        for(EntityID id : map.keySet()) {
            AmbulanceTeamInfo info = map.get(id);
            if(info != null && info.target != null) {
                result.put(id, info.target);
            }
        }
        return result;
    }//return the agentID and targetid

    private List<StandardEntity> getActionAgents(Map<EntityID, AmbulanceTeamInfo> map) {
        List<StandardEntity> result = new ArrayList<>();
        int thewholeAT=0; 
         //calculate the number of AT.
         
        for(StandardEntity entity : this.worldInfo.getEntitiesOfType(StandardEntityURN.AMBULANCE_TEAM)) {
            AmbulanceTeamInfo info = map.get(entity.getID());
            //System.out.println(" comdt "+info.commandTime + " time "+this.agentInfo.getTime() + "  (targeid) "+  info.target+ " (id) " + entity.getID()+" canNewAction "+ info.canNewAction + " ispositondefine "+((AmbulanceTeam)entity).isPositionDefined());
            if(info != null && info.canNewAction && ((AmbulanceTeam)entity).isPositionDefined()) 
            {
                result.add(entity);
                thewholeAT=thewholeAT+1;
            }
        }
        //System.out.println(this.agentInfo.getTime() + " the //System can know the number is "+thewholeAT);
        return result;
    }//return the AT :1.no target 2.position defined

    
    private AmbulanceTeamInfo update(AmbulanceTeamInfo info, MessageAmbulanceTeam message) {
        if(message.isBuriednessDefined() && message.getBuriedness() > 0) {
            info.canNewAction = false;
            if (info.target != null) {
                this.targetHumans.add(info.target);
                info.target = null;
            }
            return info;
        }
        //message is the currentAT and the info is in map
        if(message.getAction() == MessageAmbulanceTeam.ACTION_REST) {
            info.canNewAction = true;
            if (info.target != null) {
                this.targetHumans.add(info.target);
                info.target = null;
            }
            //if rest ,put target in 
        } else if(message.getAction() == MessageAmbulanceTeam.ACTION_MOVE) 
        {
            if(message.getTargetID() != null) 
            {
                StandardEntity entity = this.worldInfo.getEntity(message.getTargetID());
                if(entity != null)
                {
                    if(entity instanceof Area) 
                    {
                    	
                    	
                        if(entity.getStandardURN() == REFUGE) 
                        {
                            info.canNewAction = false;
                            return info;
                        }//if the target changed from id to refuge ,go on
                        
                        StandardEntity targetEntity = this.worldInfo.getEntity(info.target);
                        //if not the refuge,and judge
                        if (targetEntity != null) 
                        {
                            if(targetEntity instanceof Human) {
                                targetEntity = this.worldInfo.getPosition((Human)targetEntity);
                                if(targetEntity == null) {
                                    this.priorityHumans.remove(info.target);
                                    this.targetHumans.remove(info.target);
                                    info.canNewAction = true;
                                    info.target = null;
                                    return info;
                                                         }
                                                              }//position not defined ,remove it 
                            //if target is human ,targetenetity is the position
                            if (targetEntity.getID().getValue() == entity.getID().getValue()) 
                            {   info.canNewAction = false;//the two target is same
                            } else {
                                info.canNewAction = true;
                                if (info.target != null) 
                                {
                                    this.targetHumans.add(info.target);
                                    info.target = null;
                                }//if not equip,put target into targethuman.
                                   }
                        } else {
                            info.canNewAction = true;
                            info.target = null;
                        }
                        return info;
                    //the situation of AREA
                    } else if(entity instanceof Human) 
                    {
                        if(entity.getID().getValue() == info.target.getValue()) 
                        {
                            info.canNewAction = false;
                        } else {
                            info.canNewAction = true;
                            this.targetHumans.add(info.target);
                            this.targetHumans.add(entity.getID());
                            info.target = null;
                               }
                        return info;
                     }
                }
            }//if the target had the target,the centre will give up
            info.canNewAction = true;
            if(info.target != null) 
              {
                this.targetHumans.add(info.target);
                info.target = null;
              }
            //if current agent don't have the target,set it up
        } else if(message.getAction() == MessageAmbulanceTeam.ACTION_RESCUE) {
            info.canNewAction = true;
            if(info.target != null) {
                this.targetHumans.add(info.target);
                info.target = null;
            }//if the at is rescue,then give up
        } else if(message.getAction() == MessageAmbulanceTeam.ACTION_LOAD) {
            info.canNewAction = false;
        } else if(message.getAction() == MessageAmbulanceTeam.ACTION_UNLOAD) {
            info.canNewAction = true;
            this.priorityHumans.remove(info.target);
            this.targetHumans.remove(info.target);
            info.target = null;
        }
        return info;
    }


    private class AmbulanceTeamInfo {
        EntityID agentID;
        EntityID target;
        boolean canNewAction;
        int commandTime;

        AmbulanceTeamInfo(EntityID id) {
            agentID = id;
            target = null;
            canNewAction = true;
            commandTime = -1;
        }
    }//return the targetid and agentid

    private class DistanceSorter implements Comparator<StandardEntity> {
        private StandardEntity reference;
        private WorldInfo worldInfo;

        DistanceSorter(WorldInfo wi, StandardEntity reference) {
            this.reference = reference;
            this.worldInfo = wi;
        }

        public int compare(StandardEntity a, StandardEntity b) {
            int d1 = this.worldInfo.getDistance(this.reference, a);
            int d2 = this.worldInfo.getDistance(this.reference, b);
            return d1 - d2;
        }
    }

   /* the new change
    * according to the density of civilian  decides to 
    * sort our targethumans and priorityHuamns
    * 
    * */
   private class civilianSorter implements Comparator<EntityID>
   {
	   private StandardEntity reference;
	   private WorldInfo worldInfo;
	   
	   civilianSorter(WorldInfo wi)
	   {
		   this.worldInfo = wi;
	   }
	   
	   public int compare(EntityID a,EntityID b)
	   {
		   StandardEntity tA = this.worldInfo.getEntity(a);
		   StandardEntity tB = this.worldInfo.getEntity(b);
		 //System.out.println(" time and the density of tA is  "+comparedensityB(tA)  + " and the density of tB is " + comparedensityB(tB));
		   return comparedensityB(tA)-comparedensityB(tB);
	   }
	   
   }
   
   //calculate the density of a target in priority
    public int comparedensityA(StandardEntity centre)
    {   
        int maindistance=0;
  
    	for(EntityID target : this.priorityHumans) 
        {
            if(this.priorityHumans.size() > 0 & target!=null) 
            {
                StandardEntity targetEntity = this.worldInfo.getEntity(target);
                int d1 = this.worldInfo.getDistance(centre, targetEntity);
                maindistance+=d1;
            }
        }
    	////System.out.println(this.agentInfo.getTime() + " the target is " + centre.getID().getValue() + " and the density is " + maindistance);
    	return maindistance;
    }
   
    //calculate the density of a target in human
    public int comparedensityB(StandardEntity centre) 
    {
    	int maindistance=0;
    	  
    	for(EntityID target : this.targetHumans) 
        {
            if(this.targetHumans.size() > 0 & target!=null) 
            {
                StandardEntity targetEntity = this.worldInfo.getEntity(target);
                int d1 = this.worldInfo.getDistance(centre, targetEntity);
                maindistance+=d1;
            }
        }
    	//System.out.println(this.agentInfo.getTime() + " the target is " + centre.getID().getValue() + " and the density is " + maindistance);
    	return maindistance;
    }
    
    
   //transform the target
    private List<EntityID> getlisttarget(Collection<EntityID> priorityHumans) 
    {
    	List<EntityID> result = new ArrayList<>();
      
         
        for(EntityID entityid : this.priorityHumans) 
        {
            
            if(entityid != null ) 
            {
            	
                result.add(entityid);
                
            }
        }
        ////System.out.println(this.agentInfo.getTime() + " the //System can know the number is "+thewholeAT);
        return result;
    	
    }
    
    //calculate the whole target function
    private void calculateall(EntityID change)
    {
    	for(EntityID one :this.thewholetarget)
    	{
    		if(change==one)return;
    	}
    	this.thewholetarget.add(change);
    	return;
    }
    
    
    
    
    
}
   
   
